
#include "bindhelp.h"


void initPWideStrings(CopyUnicodeToPWideString cutps, UnicodeOfPWideString uops,
  LengthOfPWideString lops, InitializePWideString ip, FinalizePWideString fp)
{
  copyUnicodeToPWideString = cutps;
  unicodeOfPWideString = uops;
  lengthOfPWideString = lops;
  initPWideString = ip;
  finalPWideString = fp;
}

template <typename T>
Q_OUTOFLINE_TEMPLATE void copyQListTemplateToPtrIntArray(QList<T> &qlist, PPtrIntArray parr)
{
  int len = qlist.count();
  PTRINT *array;
  setPtrIntArrayLength(parr, len);
  array = (PTRINT *)getPtrIntArrayAddr(parr);
  for (int i = 0; i < len; i++)
    array[i] = (PTRINT)qlist[i];
}



template <typename T>
Q_OUTOFLINE_TEMPLATE void copyPtrIntArrayToQListTemplate(PPtrIntArray parr,QList<T> &qlist)
{
  int len = getPtrIntArrayLength(parr);
  PTRINT *array = (PTRINT *)getPtrIntArrayAddr(parr);
  qlist.clear();
  for (int i = 0; i < len; i++)
    qlist.append((T)array[i]);
}


//===============================================================================
// Only valid for T not castable to PtrInt 
// will allocate new T to get *T which is castable to PtrInt
//===============================================================================

template <typename T>
Q_OUTOFLINE_TEMPLATE void copyQListTemplateToPtrIntArrayWithNew(QList<T> &qlist, PPtrIntArray parr)
{
  int len = qlist.count();
  PTRINT *array;
  setPtrIntArrayLength(parr, len);
  array = (PTRINT *)getPtrIntArrayAddr(parr);
  for (int i = 0; i < len; i++)
    array[i] = (PTRINT)(new T(qlist[i]));
}


void initializePPtrIntArray(GetPtrIntArrayAddr gaa, GetPtrIntArrayLength gal, SetPtrIntArrayLength sal)
{
  getPtrIntArrayAddr = gaa;
  getPtrIntArrayLength = gal;
  setPtrIntArrayLength = sal;
}


void copyQVectorQRealToQRealArray(QVector<qreal> &qvector, PQRealArray parr)
{
  int len = qvector.size();
  setQRealArrayLength(parr, len);
  qreal *array = getQRealArrayAddr(parr);
  for (int i = 0; i < len; i++)
    array[i] = qvector.at(i);
}



void copyQRealArrayToQVectorQReal(PQRealArray parr,QVector<qreal> &qvector)
{
  int len = getQRealArrayLength(parr);
  qreal *array = getQRealArrayAddr(parr);
  qvector.resize(len);
  for (int i = 0; i < len; i++)
    qvector[i] = array[i];
}

void initializeQRealArray(GetQRealArrayAddr gaa, GetQRealArrayLength gal, SetQRealArrayLength sal)
{
  getQRealArrayAddr = gaa;
  getQRealArrayLength = gal;
  setQRealArrayLength = sal;
}

