//******************************************************************************
//  Copyright (c) 2005-2008 by Jan Van hijfte
//
//  See the included file COPYING.TXT for details about the copyright.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//******************************************************************************


#ifndef C_QPICTURE_H
#define C_QPICTURE_H

C_EXPORT QPictureH QPicture_create(int formatVersion);
C_EXPORT void QPicture_destroy(QPictureH handle);
C_EXPORT QPictureH QPicture_create2(const QPictureH p1);
C_EXPORT bool QPicture_isNull(QPictureH handle);
C_EXPORT int QPicture_devType(QPictureH handle);
C_EXPORT uint QPicture_size(QPictureH handle);
C_EXPORT const char* QPicture_data(QPictureH handle);
C_EXPORT void QPicture_setData(QPictureH handle, const char* data, uint size);
C_EXPORT bool QPicture_play(QPictureH handle, QPainterH p);
C_EXPORT bool QPicture_load(QPictureH handle, QIODeviceH dev, const char* format);
C_EXPORT bool QPicture_load2(QPictureH handle, PWideString fileName, const char* format);
C_EXPORT bool QPicture_save(QPictureH handle, QIODeviceH dev, const char* format);
C_EXPORT bool QPicture_save2(QPictureH handle, PWideString fileName, const char* format);
C_EXPORT void QPicture_boundingRect(QPictureH handle, PRect retval);
C_EXPORT void QPicture_setBoundingRect(QPictureH handle, PRect r);
C_EXPORT void QPicture_detach(QPictureH handle);
C_EXPORT bool QPicture_isDetached(QPictureH handle);
C_EXPORT const char* QPicture_pictureFormat(PWideString fileName);
C_EXPORT void QPicture_inputFormatList(QStringListH retval);
C_EXPORT void QPicture_outputFormatList(QStringListH retval);
C_EXPORT QPaintEngineH QPicture_paintEngine(QPictureH handle);
C_EXPORT QPictureIOH QPictureIO_create();
C_EXPORT void QPictureIO_destroy(QPictureIOH handle);
C_EXPORT QPictureIOH QPictureIO_create2(QIODeviceH ioDevice, const char* format);
C_EXPORT QPictureIOH QPictureIO_create3(PWideString fileName, const char* format);
C_EXPORT const QPictureH QPictureIO_picture(QPictureIOH handle);
C_EXPORT int QPictureIO_status(QPictureIOH handle);
C_EXPORT const char* QPictureIO_format(QPictureIOH handle);
C_EXPORT QIODeviceH QPictureIO_ioDevice(QPictureIOH handle);
C_EXPORT void QPictureIO_fileName(QPictureIOH handle, PWideString retval);
C_EXPORT int QPictureIO_quality(QPictureIOH handle);
C_EXPORT void QPictureIO_description(QPictureIOH handle, PWideString retval);
C_EXPORT const char* QPictureIO_parameters(QPictureIOH handle);
C_EXPORT float QPictureIO_gamma(QPictureIOH handle);
C_EXPORT void QPictureIO_setPicture(QPictureIOH handle, const QPictureH p1);
C_EXPORT void QPictureIO_setStatus(QPictureIOH handle, int p1);
C_EXPORT void QPictureIO_setFormat(QPictureIOH handle, const char* p1);
C_EXPORT void QPictureIO_setIODevice(QPictureIOH handle, QIODeviceH p1);
C_EXPORT void QPictureIO_setFileName(QPictureIOH handle, PWideString p1);
C_EXPORT void QPictureIO_setQuality(QPictureIOH handle, int p1);
C_EXPORT void QPictureIO_setDescription(QPictureIOH handle, PWideString p1);
C_EXPORT void QPictureIO_setParameters(QPictureIOH handle, const char* p1);
C_EXPORT void QPictureIO_setGamma(QPictureIOH handle, float p1);
C_EXPORT bool QPictureIO_read(QPictureIOH handle);
C_EXPORT bool QPictureIO_write(QPictureIOH handle);
C_EXPORT void QPictureIO_pictureFormat(QByteArrayH retval, PWideString fileName);
C_EXPORT void QPictureIO_pictureFormat2(QByteArrayH retval, QIODeviceH p1);
C_EXPORT void QPictureIO_defineIOHandler(const char* format, const char* header, const char* flags, picture_io_handler read_picture, picture_io_handler write_picture);

#endif
